local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.Chi = s.Power("player", SPELL_POWER_CHI )
	x.MaxChi = s.MaxPower("player", SPELL_POWER_CHI)
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown() + x.Lag
	x.Spec = s.TalentMastery()
	x.ActiveEnemies = a.ActiveEnemies()
	x.MaxHealth = s.MaxHealth("player")
	x.TalentChiExplosionEnabled = s.HasTalent(152174--[[Chi Explosion]])
	x.TalentRushingJadeWindEnabled = s.HasTalent(116847--[[Rushing Jade Wind]])
	if x.CombatStart == 0 or x.CombatStart == nil then
		x.Time = 0
	else
		x.Time = GetTime() - x.CombatStart
	end
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	a.FlashAll("Nimble Brew", "Tiger's Lust", "Charging Ox Wave", "Diffuse Magic", "Detox") -- Talents
	if x.Spec == 1 then
		-- Brewmaster
		x.IncomingDamage1500ms = a.incomingDamage1500ms() > x.MaxHealth * 0.4
		x.BuffShuffleRemains = s.BuffDuration(115307--[[Shuffle]], "player", nil, false, false, true)
		x.BuffElusiveBrewRemains = s.BuffDuration(115308--[[Elusive Brew]], "player", nil, false, false, true)
		x.BuffElusiveBrewStacks = s.BuffStack(128939--[[Elusive Brew]], "player", nil, false, false, true)
		x.BuffSerenityRemains = s.BuffDuration(152173--[[Serenity]], "player", nil, false, false, true)
		x.BuffDampenHarmDown = (s.BuffDuration(122278--[[Dampen Harm]], "player", nil, false, false, true) <= x.Lag)
		x.BuffDiffuseMagicDown = (s.BuffDuration(122783--[[Diffuse Magic]], "player", nil, false, false, true) <= x.Lag)
		x.BuffFortifyingBrewDown = (s.BuffDuration(115203--[[Fortifying Brew]], "player", nil, false, false, true) <= x.Lag)
		x.Energy = s.Power("player", SPELL_POWER_ENERGY )
		x.EnergyPerSecond = a.energyRegeneration()
		x.RealEnergy = x.Energy + s.GlobalCooldown() * x.EnergyPerSecond
		x.TimeToMax = (100 - x.Energy) / x.EnergyPerSecond
		x.StaggerAmount = a.getStagger()
		x.CooldownKegSmashRemains = s.SpellCooldown(121253--[[Keg Smash]])
		x.EnergyRegen = a.energyRegeneration()
		a.Flash("stance,choose=sturdy_ox")
		a.Flash("Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("Dizzying Haze") -- something to do at range, while kiting or to set up a Breath of Fire
		a.Flash("black_ox_statue")
		a.Flash("Legacy of the White Tiger")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=greater_draenic_stamina_flask",
					   "potion,name=draenic_agility")
		end
		if x.ActiveEnemies < 3 then
			a.Flash("auto_attack",
					"blood_fury,if=energy<=40",
					"berserking,if=energy<=40",
					"arcane_torrent,if=energy<=40",
--					"chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<4",
					"chi_brew,if=talent.chi_brew.enabled&chi.max-chi>=2&buff.elusive_brew_stacks.stack<=10&((charges=1&recharge_time<5)|charges=2|target.time_to_die<15)",
					"chi_brew,if=(chi<1&stagger.heavy)|(chi<2&buff.shuffle.down)",
--					"gift_of_the_ox,if=buff.gift_of_the_ox.react&incoming_damage_1500ms",
					"diffuse_magic,if=incoming_damage_1500ms&buff.fortifying_brew.down",
					"dampen_harm,if=incoming_damage_1500ms&buff.fortifying_brew.down&buff.elusive_brew_activated.down",
					"fortifying_brew,if=incoming_damage_1500ms&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down",
					"elusive_brew,if=buff.elusive_brew_stacks.react>=9&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down",
					"invoke_xuen,if=talent.invoke_xuen.enabled&target.time_to_die>15&buff.shuffle.remains>=3&buff.serenity.down",
					"serenity,if=talent.serenity.enabled&cooldown.keg_smash.remains>6",
					"potion,name=draenic_armor,if=(buff.fortifying_brew.down&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down)",
					"purifying_brew,if=!talent.chi_explosion.enabled&stagger.heavy",
					"blackout_kick,if=buff.shuffle.down",
					"purifying_brew,if=buff.serenity.up",
					"purifying_brew,if=!talent.chi_explosion.enabled&stagger.moderate&buff.shuffle.remains>=6",
					"guard,if=(charges=1&recharge_time<5)|charges=2|target.time_to_die<15",
					"guard,if=incoming_damage_10s>=health.max*0.5",
					"keg_smash,if=chi.max-chi>=1&!buff.serenity.remains",
					"chi_burst,if=(energy+(energy.regen*gcd))<100",
					"chi_wave,if=(energy+(energy.regen*gcd))<100",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking&(energy+(energy.regen*gcd))<100",
					"chi_explosion,if=chi>=3",
					"blackout_kick,if=chi>=4",
					"blackout_kick,if=buff.shuffle.remains<=3&cooldown.keg_smash.remains>=gcd",
					"blackout_kick,if=buff.serenity.up",
					"expel_harm,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80",
					"jab,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&cooldown.expel_harm.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80",
					"tiger_palm",
					"crackling_jade_lightning")
		else
			a.Flash("auto_attack",
					"blood_fury,if=energy<=40",
					"berserking,if=energy<=40",
					"arcane_torrent,if=energy<=40",
--					"chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<4",
					"chi_brew,if=talent.chi_brew.enabled&chi.max-chi>=2&buff.elusive_brew_stacks.stack<=10&((charges=1&recharge_time<5)|charges=2|target.time_to_die<15)",
					"chi_brew,if=(chi<1&stagger.heavy)|(chi<2&buff.shuffle.down)",
--					"gift_of_the_ox,if=buff.gift_of_the_ox.react&incoming_damage_1500ms",
					"diffuse_magic,if=incoming_damage_1500ms&buff.fortifying_brew.down",
					"dampen_harm,if=incoming_damage_1500ms&buff.fortifying_brew.down&buff.elusive_brew_activated.down",
					"fortifying_brew,if=incoming_damage_1500ms&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down",
					"elusive_brew,if=buff.elusive_brew_stacks.react>=9&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down",
					"invoke_xuen,if=talent.invoke_xuen.enabled&target.time_to_die>15&buff.shuffle.remains>=3&buff.serenity.down",
					"serenity,if=talent.serenity.enabled&cooldown.keg_smash.remains>6",
					"potion,name=draenic_armor,if=(buff.fortifying_brew.down&(buff.dampen_harm.down|buff.diffuse_magic.down)&buff.elusive_brew_activated.down)",
					"purifying_brew,if=stagger.heavy",
					"blackout_kick,if=buff.shuffle.down",
					"purifying_brew,if=buff.serenity.up",
					"purifying_brew,if=!talent.chi_explosion.enabled&stagger.moderate&buff.shuffle.remains>=6",
					"guard,if=(charges=1&recharge_time<5)|charges=2|target.time_to_die<15",
					"guard,if=incoming_damage_10s>=health.max*0.5",
					"breath_of_fire,if=(chi>=3|buff.serenity.up)&buff.shuffle.remains>=6&dot.breath_of_fire.remains<=2.4&!talent.chi_explosion.enabled",
					"keg_smash,if=chi.max-chi>=1&!buff.serenity.remains",
					"rushing_jade_wind,if=chi.max-chi>=1&!buff.serenity.remains&talent.rushing_jade_wind.enabled",
					"chi_burst,if=(energy+(energy.regen*gcd))<100",
					"chi_wave,if=(energy+(energy.regen*gcd))<100",
					"zen_sphere,cycle_targets=1,if=talent.zen_sphere.enabled&!dot.zen_sphere.ticking&(energy+(energy.regen*gcd))<100",
					"chi_explosion,if=chi>=4",
					"blackout_kick,if=chi>=4",
					"blackout_kick,if=buff.shuffle.remains<=3&cooldown.keg_smash.remains>=gcd",
					"blackout_kick,if=buff.serenity.up",
					"expel_harm,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80",
					"jab,if=chi.max-chi>=1&cooldown.keg_smash.remains>=gcd&cooldown.expel_harm.remains>=gcd&(energy+(energy.regen*(cooldown.keg_smash.remains)))>=80",
					"tiger_palm",
					"crackling_jade_lightning")
		end
	elseif x.Spec == 2 then
		-- Mistweaver
		a.Flash("stance,choose=wise_serpent")
		a.Flash("jade_serpent_statue")
		a.Flash("Legacy of the Emperor")
		a.Flash("Roll")
	elseif x.Spec == 3 then
		-- Windwalker
		x.Energy = s.Power("player", SPELL_POWER_ENERGY )
		x.EnergyPerSecond = a.energyRegeneration()
		x.RealEnergy = x.Energy + s.GlobalCooldown() * x.EnergyPerSecond
		x.TimeToMax = (100 - x.Energy) / x.EnergyPerSecond
		x.DebuffRisingSunKickRemains = s.MyDebuffDuration(130320--[[Rising Sun Kick]], "target", nil, false, false, true)
		x.BuffSerenityRemains = s.BuffDuration(152173--[[Serenity]], "player", nil, false, false, true)
		x.TalentSerenityEnabled = s.HasTalent(152173--[[Serenity]])
		x.TalentChiBrewEnabled = s.HasTalent(115399--[[Chi Brew]])
		
		x.CanTigerPalm = (x.Chi >= 1 or s.BuffDuration(118864--[[Combo Breaker: Tiger Palm]], "player", nil, false, false, true) > x.GCD)
		x.CanBlackoutKick = not x.TalentChiExplosionEnabled and (x.Chi >= 2 or s.BuffDuration(116768--[[Combo Breaker: Blackout Kick]], "player", nil, false, false, true) > x.GCD)
		
		x.BuffTigerPowerRemains = s.BuffDuration(125359--[[Tiger Power]], "player", nil, false, false, true)
		x.BuffTigereyeBrewRemains = s.BuffDuration(116740--[[Tigereye Brew]], "player", nil, false, false, true)
		x.BuffTigereyeBrewStack = s.BuffStack(125195--[[Tigereye Brew]], "player", nil, false, false, true)
		x.CooldownFistsOfFuryRemains = s.SpellCooldown(113656--[[Fists of Fury]])
		
		a.Flash("stance,choose=fierce_tiger")
		a.Flash("Legacy of the White Tiger")
		a.Flash("Flying Serpent Kick", "Roll")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=greater_draenic_agility_flask",
			           "potion,name=draenic_agility")
		end
		
		x.ActionListOpener = x.TalentSerenityEnabled and x.TalentChiBrewEnabled and x.CooldownFistsOfFuryRemains == 0 and x.Time < 20
		x.ActionListSingleTarget = x.ActiveEnemies < 3 and not x.TalentChiExplosionEnabled
		x.ActionListSingleChix = x.ActiveEnemies == 1 and x.TalentChiExplosionEnabled
		x.ActionListCleaveChix = (x.ActiveEnemies == 2 or (x.ActiveEnemies == 3 and not x.TalentRushingJadeWindEnabled)) and x.TalentChiExplosionEnabled
		x.ActionListAoENoRJW = x.ActiveEnemies >= 3 and not x.TalentRushingJadeWindEnabled and not x.TalentChiExplosionEnabled
		x.ActionListAoENoRJWChix = x.ActiveEnemies >= 4 and not x.TalentRushingJadeWindEnabled and x.TalentChiExplosionEnabled
		x.ActionListAoERJW = x.ActiveEnemies >= 3 and x.TalentRushingJadeWindEnabled

		a.Flash("auto_attack",
				"invoke_xuen",
--				"storm_earth_and_fire,target=2,if=debuff.storm_earth_and_fire_target.down",
--				"storm_earth_and_fire,target=3,if=debuff.storm_earth_and_fire_target.down",
-- start opener
				"opener:tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9",
				"opener:blood_fury,if=buff.tigereye_brew_use.up",
				"opener:berserking,if=buff.tigereye_brew_use.up",
				"opener:arcane_torrent,if=buff.tigereye_brew_use.up&chi.max-chi>=1",
				"opener:fists_of_fury,if=buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.serenity.up&buff.serenity.remains<1.5",
				"opener:tiger_palm,if=buff.tiger_power.remains<2",
				"opener:use_item,name=beating_heart_of_the_mountain",
				"opener:rising_sun_kick",
				"opener:blackout_kick,if=chi.max-chi<=1&cooldown.chi_brew.up|buff.serenity.up",
				"opener:chi_brew,if=chi.max-chi>=2",
				"opener:serenity,if=chi.max-chi<=2",
				"opener:jab,if=chi.max-chi>=2&!buff.serenity.up",
-- end opener
--				"chi_sphere,if=talent.power_strikes.enabled&buff.chi_sphere.react&chi<chi.max",
				"potion,name=draenic_agility,if=buff.serenity.up|(!talent.serenity.enabled&(trinket.proc.agility.react|trinket.proc.multistrike.react))|buff.bloodlust.react|target.time_to_die<=60",
				"use_item,name=beating_heart_of_the_mountain,if=buff.tigereye_brew_use.up|target.time_to_die<18",
				"blood_fury,if=buff.tigereye_brew_use.up|target.time_to_die<18",
				"berserking,if=buff.tigereye_brew_use.up|target.time_to_die<18",
				"arcane_torrent,if=chi.max-chi>=1&(buff.tigereye_brew_use.up|target.time_to_die<18)",
				"chi_brew,if=chi.max-chi>=2&((charges=1&recharge_time<=10)|charges=2|target.time_to_die<charges*10)&buff.tigereye_brew.stack<=16",
				"tiger_palm,if=!talent.chi_explosion.enabled&buff.tiger_power.remains<6.6",
				"tiger_palm,if=talent.chi_explosion.enabled&(cooldown.fists_of_fury.remains<5|cooldown.fists_of_fury.up)&buff.tiger_power.remains<5",
				"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack=20",
				"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&buff.serenity.up",
				"tigereye_brew,if=buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&cooldown.fists_of_fury.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
				"tigereye_brew,if=talent.hurricane_strike.enabled&buff.tigereye_brew_use.down&buff.tigereye_brew.stack>=9&cooldown.hurricane_strike.up&chi>=3&debuff.rising_sun_kick.up&buff.tiger_power.up",
				"tigereye_brew,if=buff.tigereye_brew_use.down&chi>=2&(buff.tigereye_brew.stack>=16|target.time_to_die<40)&debuff.rising_sun_kick.up&buff.tiger_power.up",
				"rising_sun_kick,if=(debuff.rising_sun_kick.down|debuff.rising_sun_kick.remains<3)",
				"serenity,if=chi>=2&buff.tiger_power.up&debuff.rising_sun_kick.up",
				"fists_of_fury,if=buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&energy.time_to_max>cast_time&!buff.serenity.up",
				"fortifying_brew,if=target.health.percent<10&cooldown.touch_of_death.remains=0&(glyph.touch_of_death.enabled|chi>=3)",
				"touch_of_death,if=target.health.percent<10&(glyph.touch_of_death.enabled|chi>=3)",
				"hurricane_strike,if=energy.time_to_max>cast_time&buff.tiger_power.remains>cast_time&debuff.rising_sun_kick.remains>cast_time&buff.energizing_brew.down",
				"energizing_brew,if=cooldown.fists_of_fury.remains>6&(!talent.serenity.enabled|(!buff.serenity.remains&cooldown.serenity.remains>4))&energy+energy.regen<50",
-- Start Single Target
				"st:rising_sun_kick",
				"st:blackout_kick,if=buff.combo_breaker_bok.react|buff.serenity.up",
				"st:tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
				"st:chi_wave,if=energy.time_to_max>2&buff.serenity.down",
				"st:chi_burst,if=energy.time_to_max>2&buff.serenity.down",
				"st:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down",
--				"st:chi_torpedo,if=energy.time_to_max>2&buff.serenity.down",
				"st:blackout_kick,if=chi.max-chi<2",
				"st:expel_harm,if=chi.max-chi>=2&health.percent<95",
				"st:jab,if=chi.max-chi>=2",
-- End Single Target				
-- Start Single Chix
				"st_chix:chi_explosion,if=chi>=2&buff.combo_breaker_ce.react&cooldown.fists_of_fury.remains>2",
				"st_chix:tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
				"st_chix:rising_sun_kick",
				"st_chix:chi_wave,if=energy.time_to_max>2",
				"st_chix:chi_burst,if=energy.time_to_max>2",
				"st_chix:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking",
				"st_chix:tiger_palm,if=chi=4&!buff.combo_breaker_tp.react",
				"st_chix:chi_explosion,if=chi>=3&cooldown.fists_of_fury.remains>4",
--				"st_chix:chi_torpedo,if=energy.time_to_max>2",
				"st_chix:expel_harm,if=chi.max-chi>=2&health.percent<95",
				"st_chix:jab,if=chi.max-chi>=2",
-- End Single Chix
-- Start Cleave Chix
				"cleave_chix:chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4",
				"cleave_chix:tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
				"cleave_chix:chi_wave,if=energy.time_to_max>2",
				"cleave_chix:chi_burst,if=energy.time_to_max>2",
				"cleave_chix:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking",
--				"cleave_chix:chi_torpedo,if=energy.time_to_max>2",
				"cleave_chix:expel_harm,if=chi.max-chi>=2&health.percent<95",
				"cleave_chix:jab,if=chi.max-chi>=2",
-- End Cleave Chix
-- Start AoE no RJW
				"aoe_norjw:chi_wave,if=energy.time_to_max>2&buff.serenity.down",
				"aoe_norjw:chi_burst,if=energy.time_to_max>2&buff.serenity.down",
				"aoe_norjw:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down",
				"aoe_norjw:blackout_kick,if=buff.combo_breaker_bok.react|buff.serenity.up",
				"aoe_norjw:tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
				"aoe_norjw:blackout_kick,if=chi.max-chi<2&cooldown.fists_of_fury.remains>3",
--				"aoe_norjw:chi_torpedo,if=energy.time_to_max>2",
				"aoe_norjw:spinning_crane_kick",
-- End AoE no RJW
-- Start AoE no RJW Chix
				"aoe_norjw_chix:chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4",
				"aoe_norjw_chix:rising_sun_kick,if=chi=chi.max",
				"aoe_norjw_chix:chi_wave,if=energy.time_to_max>2",
				"aoe_norjw_chix:chi_burst,if=energy.time_to_max>2",
				"aoe_norjw_chix:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking",
--				"aoe_norjw_chix:chi_torpedo,if=energy.time_to_max>2",
				"aoe_norjw_chix:spinning_crane_kick",
-- End AoE no RJW Chix
-- Start AoE RJW
				"aoe_rjw:chi_explosion,if=chi>=4&cooldown.fists_of_fury.remains>4",
				"aoe_rjw:rushing_jade_wind",
				"aoe_rjw:chi_wave,if=energy.time_to_max>2&buff.serenity.down",
				"aoe_rjw:chi_burst,if=energy.time_to_max>2&buff.serenity.down",
				"aoe_rjw:zen_sphere,cycle_targets=1,if=energy.time_to_max>2&!dot.zen_sphere.ticking&buff.serenity.down",
				"aoe_rjw:blackout_kick,if=buff.combo_breaker_bok.react|buff.serenity.up",
				"aoe_rjw:tiger_palm,if=buff.combo_breaker_tp.react&buff.combo_breaker_tp.remains<=2",
				"aoe_rjw:blackout_kick,if=chi.max-chi<2&cooldown.fists_of_fury.remains>3",
--				"aoe_rjw:chi_torpedo,if=energy.time_to_max>2",
				"aoe_rjw:expel_harm,if=chi.max-chi>=2&health.percent<95",
				"aoe_rjw:jab,if=chi.max-chi>=2"
-- Start AoE RJW
				)
		
	end
end)
